From b4d6ce67cc6eb6fcc10f2cc539621038da7f1e68 Mon Sep 17 00:00:00 2001
From: David Tolnay <dtolnay@gmail.com>
Date: Nov 30 2020 08:42:21 +0000
Subject: [PATCH 1637/2232] Merge pull request #534 from dtolnay/vecindex


Add non-const indexing for rust::Vec
---

diff --git a/include/cxx.h b/include/cxx.h
index 792d57d..8c3f241 100644
--- a/include/cxx.h
+++ b/include/cxx.h
@@ -253,10 +253,14 @@ public:
 
   const T &operator[](size_t n) const noexcept;
   const T &at(size_t n) const;
-
   const T &front() const;
   const T &back() const;
 
+  T &operator[](size_t n) noexcept;
+  T &at(size_t n);
+  T &front();
+  T &back();
+
   void reserve(size_t new_cap);
   void push_back(const T &value);
   void push_back(T &&value);
@@ -683,6 +687,30 @@ const T &Vec<T>::back() const {
 }
 
 template <typename T>
+T &Vec<T>::operator[](size_t n) noexcept {
+  auto data = reinterpret_cast<char *>(this->data());
+  return *reinterpret_cast<T *>(data + n * this->stride());
+}
+
+template <typename T>
+T &Vec<T>::at(size_t n) {
+  if (n >= this->size()) {
+    panic<std::out_of_range>("rust::Vec index out of range");
+  }
+  return (*this)[n];
+}
+
+template <typename T>
+T &Vec<T>::front() {
+  return (*this)[0];
+}
+
+template <typename T>
+T &Vec<T>::back() {
+  return (*this)[this->size() - 1];
+}
+
+template <typename T>
 void Vec<T>::reserve(size_t new_cap) {
   this->reserve_total(new_cap);
 }

